//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "MyOpRx1.h"
#include "MyOpRx2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
bool restart;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button2Click(TObject *Sender)
{
 Form2->Visible=false;        
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button1Click(TObject *Sender)
{
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ));
  ini->WriteString("OP-32","MYCALL",Edit1->Text);
  ini->WriteString("OP-32","MYQTH",Edit2->Text);
  ini->WriteString("OP-32","FILE",Edit3->Text);
  ini->WriteString("OP-32","CAPTURE_FILENAME", Edit11->Text);
  ini->WriteString("OP-32","CAPTURE_PATH", Edit4->Text);
  ini->WriteString("OP-32","EXECUTE_IF_DECODED", Edit12->Text);
  ini->WriteBool("OP-32","EXECUTE_IF_DECODED_ENABLE",CheckBox1->Checked);
  AnsiString myheader;
  myheader.sprintf("%s %s Opera-32 decoded (Op32Rx RN3AUS software)",Edit1->Text, Edit2->Text);
  ini->WriteString("OP-32","MYHEADER", myheader);
  try{
  ini->WriteFloat("OP-32" ,"F_CENTER",ComboBox2->Text.ToDouble());
  ini->WriteFloat("OP-32" ,"F_DIAL",ComboBox1->Text.ToDouble());
  ini->WriteFloat("OP-32","OPERA_DB_OFFSET",Edit6->Text.ToDouble());
  ini->WriteFloat("OP-32","OP_THRESHOLD",Edit5->Text.ToDouble());
  ini->WriteFloat("OP-32","OPDS_THRESHOLD",Edit8->Text.ToDouble());
  ini->WriteFloat("OP-32","OPDS_MAX1MAX2_THRESHOLD",Edit7->Text.ToDouble());
  ini->WriteInteger("OP-32","CORRELATOR_237_THRESHOLD",Edit9->Text.ToInt());
  ini->WriteInteger("OP-32","TIME_CALL_BLOCKED",Edit10->Text.ToInt());
  }catch(...){}
  
 delete ini;
 Form2->Visible=false;
 Form1->read_ini_file(restart);
 restart=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm2::ComboBox1Change(TObject *Sender)
{
 try{ComboBox1->Text.ToDouble();}
 catch(...){ComboBox1->Text=ComboBox1->Text.SubString(1,ComboBox1->Text.Length()-1);}
 restart=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::ComboBox2Change(TObject *Sender)
{
 try{ComboBox2->Text.ToDouble();}
 catch(...){ComboBox2->Text=ComboBox2->Text.SubString(1,ComboBox2->Text.Length()-1);}
 restart=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Edit5Change(TObject *Sender)
{
 try{Edit5->Text.ToDouble();}
 catch(...){Edit5->Text=Edit5->Text.SubString(1,Edit5->Text.Length()-1);}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Edit6Change(TObject *Sender)
{
 try{Edit6->Text.ToDouble();}
 catch(...){Edit6->Text=Edit6->Text.SubString(1,Edit6->Text.Length()-1);}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Edit7Change(TObject *Sender)
{
 try{Edit7->Text.ToDouble();}
 catch(...){Edit7->Text=Edit6->Text.SubString(1,Edit7->Text.Length()-1);}
 AnsiString s;
 double Pf=Edit7->Text.ToDouble();
 if(Pf<1.55)Label10->Font->Color=clRed; else Label10->Font->Color=clGreen;
 if(Pf>0){Pf=10.0*log10(Pf);
          s.sprintf("%.1f dB",Pf);
          Label10->Caption=s;
         }
}
//---------------------------------------------------------------------------


void __fastcall TForm2::Edit8Change(TObject *Sender)
{
  try{Edit8->Text.ToDouble();}
  catch(...){Edit8->Text=Edit8->Text.SubString(1,Edit8->Text.Length()-1);}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Edit9Change(TObject *Sender)
{
  try{Edit9->Text.ToInt();}
 catch(...){Edit9->Text=Edit9->Text.SubString(1,Edit9->Text.Length()-1); return;}
 double Pf=0;
 int k=Edit9->Text.ToInt();
 int nk=237-k;
 double c=1;
 while(k<237)
 { double c1=1;
   for(int i=k+1; i<=237; i++) c1=c1*i;
   for(int i=1; i<=nk; i++) c1=c1/i;
   c+=c1;
   k++; nk=237-k;
 }
 Pf= c / pow(2,237);
 AnsiString s;
 s.sprintf("%e",Pf);
 Label15->Caption=s;
 if(Pf>1e-7)Label15->Font->Color=clRed; else Label15->Font->Color=clGreen;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Edit10Change(TObject *Sender)
{
  try{Edit10->Text.ToInt();}
 catch(...){Edit10->Text=Edit10->Text.SubString(1,Edit10->Text.Length()-1); return;}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button3Click(TObject *Sender)
{
 AnsiString runstr="";//start ";
 runstr=runstr + Edit12->Text;
 //system(runstr.c_str());
 int r=WinExec(runstr.c_str(),SW_SHOWNA);
 if(r<=31) Button3->Caption="Err"; else Button3->Caption="Ok";
}
//---------------------------------------------------------------------------



void __fastcall TForm2::UpDown3Changing(TObject *Sender, bool &AllowChange)
{static int oldpos;
 try{
  float ff=Edit7->Text.ToDouble();
  if(UpDown3->Position > oldpos) ff=ff+0.01;
  if(UpDown3->Position < oldpos) ff=ff-0.01;
  oldpos= UpDown3->Position;
  AnsiString ffss;
  ffss.sprintf("%.2f",ff);
  int dotpos=ffss.Pos("."); ffss.Delete(dotpos,1);ffss.Insert(",",dotpos);
  Edit7->Text=ffss;
 }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::UpDown4Click(TObject *Sender, TUDBtnType Button)
{
  static int oldpos;
 try{
  float ff=Edit8->Text.ToDouble();
  if(UpDown4->Position > oldpos) ff=ff+0.01;
  if(UpDown4->Position < oldpos) ff=ff-0.01;
  oldpos= UpDown4->Position;
  AnsiString ffss;
  ffss.sprintf("%.2f",ff);
  int dotpos=ffss.Pos("."); ffss.Delete(dotpos,1);ffss.Insert(",",dotpos);
  Edit8->Text=ffss;
 }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
 static int oldpos;
 try{
  float ff=Edit5->Text.ToDouble();
  if(UpDown1->Position > oldpos) ff=ff+0.01;
  if(UpDown1->Position < oldpos) ff=ff-0.01;
  oldpos= UpDown1->Position;
  AnsiString ffss;
  ffss.sprintf("%.2f",ff);
  int dotpos=ffss.Pos("."); ffss.Delete(dotpos,1);ffss.Insert(",",dotpos);
  Edit5->Text=ffss;
 }catch(...){}
}
//---------------------------------------------------------------------------

void __fastcall TForm2::UpDown2Click(TObject *Sender, TUDBtnType Button)
{
 static int oldpos;
 try{
  float ff=Edit6->Text.ToDouble();
  if(UpDown2->Position > oldpos) ff=ff+0.01;
  if(UpDown2->Position < oldpos) ff=ff-0.01;
  oldpos= UpDown2->Position;
  AnsiString ffss;
  ffss.sprintf("%.2f",ff);
  int dotpos=ffss.Pos("."); ffss.Delete(dotpos,1);ffss.Insert(",",dotpos);
  Edit6->Text=ffss;
 }catch(...){}
}
//---------------------------------------------------------------------------


void __fastcall TForm2::Edit12Change(TObject *Sender)
{
  Button3->Caption="test";
}
//---------------------------------------------------------------------------

